   [1]NTFS-3G
     * [2]Tuxera Home

     * [3]NTFS-3G Home
          + [4]Questions & Answers
          + [5]Problem Submission
          + [6]Forum
          + [7]Mailing Lists
          + [8]Release History

     * [9]Advanced Features

     * [10]Security

     * [11]Using a Native ACL
     * [12]User Mapping
     * [13]POSIX ACLs
     * [14]Mount Options
     * [15]Limitations

     * [16]Junctions & Symlinks

     * [17]Directory Junctions
     * [18]Volume Junctions
     * [19]Symbolic Links

     * [20]Extended Attributes
     * [21]Data Compression
     * [22]User Mapping Tool
     * [23]Security Data Auditing

     * [24]OpenIndiana

                     Changelog for the Advanced Versions

   Experimental versions are PURPLE
   Beta test versions are RED
   Release candidates are BLUE
   Release versions are GREEN
   The advanced versions are identified from the standard version they are
   derived from. The changes which were made in the original stable
   version are not repeated here (unless they were first made in an
   advanced version).
   Items prefixed by a hollow bullet mainly impact builds with Posix ACL
   activated.

Version 2014.2.15AR.1 (Apr 7, 2014)

     * fixed ioctl() error return for ntfsclone on Windows
     * implemented an extended attribute to get/set EAs
     * added a license section to the README file
     * mapped the runlist when filling an initial hole

Version 2013.1.13AR.4 (Feb 11, 2014)

     * logged more details when an attribute is not found
     * ignored unmapped regions when checking whether sparse (Forrest Liu)
     * made ntfsdecrypt compatible with libgrypt-1.6
     * allowed setting the serial number to 0x8000000000000000 or greater
       (E. Talsma)
     * fixed an endianness error in ntfsundelete
     * avoided displaying sync errors in ntfscp with --no-action
     * added option --min-fragments to reduce fragmentation in ntfscp
     * improved the description of the silent option in the manual
     * fixed an erroneous reference to compression in the manual
     * fixed default option for compression in the manual
     * avoided unnormalized parent directory name in ntfscp
     * avoided double opening of parent directory name in ntfscp
     * reset the output file to favour appending to image in ntfsclone
     * avoided full runlist updating in more situations
     * traced dirtying runlists and updated them accordingly
     * used MFT record 15 for the first extent to MFT:DATA
     * updated ctime after setting an ACL
     * fixed marking device as closed (Windows variant)
     * fixed endianness bugs in ntfscluster
     * improved the warning for analyzing an extent in ntfscluster
       (utils.c)
     * added a summary of inodes found by ntfscluster
     * rejected reserved files names when option windows_names is set
     * fixed checking whether utimensat() applies to current atime
     * accepted encryption keys whose EFS purpose is not the first one
     * implemented updating an encrypted file in ntfsdecrypt
     * switched to the relocated bitmap for delayed relocations in
       ntfsresize

Version 2013.1.13AR.3 (Sep 18, 2013)

     * fixed processing compressed data beyond file size
     * set the backup boot sector in ntfsresize when the size is reliable
     * reserved a single sector for the backup boot sector
     * improved the manual description of the size option of ntfsresize
     * fixed delayed deletion of files opened multiple times (lowntfs-3g)
     * output the modification time when scanning files by ntfsundelete
     * forced 64-bit computation of inode number in ntfsundelete
     * silenced a compiler warning in ntfs-3g.probe
     * fixed format translations for Windows
     * fixed dealing with errors getting the file size from Windows
     * fixed creating a new image file on Windows
     * fixed testing for a wiped out stream
     * fixed expanding a resident attribute without inserting holes
     * silenced warnings by gcc >= 4.8 about aliasing
     * silenced warnings by gcc >= 4.8 about non-checked return values
     * fixed a memory leak in ntfscmp
     * allowed DACLs to to not have any ACE

Version 2013.1.13AR.2 (May 8, 2013)

     * made compilation with --enable-really-static option to ./configure
       work (Anton Altaparmakov)
     * switched to /proc/mounts for checking existing mounts
     * fixed trying to update the MFT and Bitmap on a test run of
       ntfsresize
     * fixed updating all the MFT runs in a relocated MFT in ntfsresize
     * removed obsoleted references to utime_omit_ok
     * fixed usa checking by ntfsck on 4K sectors
     * fixed the reversal of slashes in relative Windows-type symlinks
     * fixed size truncation when checking for Interix types on i686

Version 2013.1.13AR.1 (Feb 13, 2013)

     * added directions for getting a user mapping proposal through
       secaudit
     * fixed wiping fragmented metadata when creating a metadata image
     * upgraded the Win32 interface for use with ntfsprogs
     * added a new option for testing the consistency of an image
     * fixed the ntfsfix option for testing in the manual
     * added a display of the location of an inconsistency in an image
     * allowed cloning a file system despite allocation errors
     * avoided meaningless errors logging during ntfsundelete scans
     * made possible to run ntfsundelete on systems with no regex.h
     * enabled relocating the MFT when shrinking a volume
     * eliminated summary of verbose output in non-verbose mode (Erik
       Larsson)
     * cleaned selecting stdout or stderr for messages from ntfsclone
     * fixed bad copying of the backup boot sector in ntfsclone
     * ported ntfsclone to Windows
     * translated %ll print formats to %I64 on Windows
     * ported ntfsundelete to Windows
     * rejected reading a volume from stdin in ntfsclone
     * fixed setting a magic header to unreadable sectors in ntfsclone
     * fixed rescuing clusters by physical sectors in ntfsclone
     * initialized the random generator for the internal guid generator
     * made the meaning of the size argument of ntfsresize more clear in
       the manual
     * added use of hd library to get the legacy BIOS geometry (Anton
       Altaparmakov)
     * increased the maximum format size on Windows

Version 2012.1.15AR.8 (Oct 13, 2012)

     * prevented partitions with metadata cached in windows from being
       mounted
     * improved the consistency check of MFT and MFTMirr locations
     * disabled getting/setting DOS names on hardlinked files
     * added directions for getting a user mapping proposal through
       secaudit
     * fixed wiping fragmented metadata when creating a metadata image

Version 2012.1.15AR.7 (Sep 12, 2012)

     * processed ACLs with no mentioned rights for owner (used by
       Windows8)
     * extended Windows-type ACL inheritance, as needed by Windows 8
     * ignored permissions when listing xattrs for special files
     * fixed displaying progress percentage for metadata images
     * avoided an unnecessary runlist update when appending data to a file
     * avoided having a hardcoded knowledge of upcase table size in mkntfs
     * fixed the computation of named stream size in mkntfs
     * inserted an $Info stream in $UpCase to comply with Windows 8
     * made secaudit runnable on OpenIndiana
     * restored interpreting UTIME_NOW and UTIME_OMIT from external fuse
       >= 2.9
     * fixed Windows-type ACL inheritance for creator-owner
     * fixed the returned files types in readdir()
     * merged libfuse for OpenIndiana into libfuse-lite
     * fixed printing all the flags in hex in ntfsinfo (Erik Larsson)
     * added an option to secaudit for getting a user mapping proposal
     * allowed SACLs to not have any ACE
     * accepted processing restart pages v 2.0 (used by Windows 8)
     * forced option ro when mounting a read-only device

Version 2012.1.15AR.6 (Jul 6, 2012)

     * added allocation data to the output of ntfsinfo -m
     * processed ACL inheritance for authenticated users
     * allowed an argument to option delay_mtime
     * added optional wiping of file tails and undelete data in ntfswipe
       (Bogdan)
     * removed the suggestions to use option remove_hiberfile
     * added inheritance of the set-group-id flag
     * added processing of SACLs to secaudit (nickgarvey)
     * extended wiping of file tails to all data attributes
     * processed junctions and symlinks whose target references another
       one
     * fixed the fixing of the backup boot sector in ntfsfix

Version 2012.1.15AR.5 (Apr 13, 2012)

     * merged OpenIndiana requirements into fuse-lite
     * implemented supplementary group checks for OpenIndiana
     * implemented the check for already mounted device on OpenIndiana
     * adapted access checks to OpenIndiana
     * kept the name of a deleted file in place for easier undeletion
     * set the hidden flag according to the latest name when
       hide_dot_files is set
     * avoided interpreting UTIME_NOW and UTIME_OMIT from external fuse
     * implemented the fixing of the backup boot sector in ntfsfix

Version 2012.1.15AR.1 (Feb 1, 2012)

     * fixed clearing the bad cluster list in ntfsfix
     * fixed clearing the end of extents when extracting metadata
     * fixed checking whether Windows 7 was hibernated
     * output the numbers of runs and fragments in ntfsinfo
     * changed error return for user access to trusted xattr
       (https://lkml.org/lkml/2011/5/27/199)
     * accepted multiple read-only mounts
     * returned unmount errors in ntfs-3g.probe (Diego Elio Pettenò)
     * preferred access control by file system on OpenIndiana
     * strengthened sanity checks on readdir/closedir
     * worked around write checks for truncate() and access(W_OK) on
       OpenIndiana
     * mounted with an absolute mount point on OpenIndiana
     * put the device name (with commas on OpenIndiana) as the last option
     * worked around basename(3) not present on OpenIndiana
     * fixed debug check for double opening after deleting an inode
     * implemented a new option -q to avoid updating the progress
       information in ntfsclone (Matthew Boyle)
     * fixed clearing user data when creating metadata images
     * implemented an option to set a new serial number in ntfsclone
     * implemented an option to set a new serial number in ntfslabel

Version 2011.10.9AR.1 (Nov 7, 2011)

     * fixed huge data writes
     * added a warning against checks at boot time to the manual
     * fixed computation of index block size with 4K sectors (Anton
       Altaparmakov)
     * fixed a test of volume dirty flag in ntfsfix
     * implemented a new option -d to clear the dirty flag if ntfsfix is
       successful
     * inserted a prefix when displaying owner and group SIDs in secaudit
     * fixed a false memory leak detection in secaudit
     * fixed building for kfreebsd (Robert Millan)

Version 2011.4.12AR.7 (Sep 14, 2011)

     * fixed overwriting a truncated file
     * fixed the truncation of dos file names
     * fixed the setting of attributes by secaudit
     * made to ignore the lower size of volume label (Erik Larsson)
     * cleaned up the code for setting a label and moved to libntfs-3g
       (Erik Larsson)
     * fixed the size limits for the volume label set by mkntfs
     * developped fixing of a self-located MFT data bug in ntfsfix
     * developped creating/restoring a metadata image in ntfsclone
     * enabled getting the sector size from an ioctl on FreeBSD and MacOSX
       (Erik Larsson)

Version 2011.4.12AR.6 (Aug 3, 2011)

     * fixed compiling ntfsfix on Sparc
     * fixed options for partial building (Erik Larsson)
     * removed an unneeded function in fuse_lowlevel
     * updated the description of the -f option in the manual for
       ntfsresize
     * reverted to old behavior for an errored reply in ntfsresize
     * avoided endless recursion when MFT extents are described in
       themselves
     * fixed several bad returns after errors (Fabian Keil)
     * removed several unneeded assignments (Fabian Keil)
     * developped the option delay_mtime to delay updates of mtime+ctime
     * developped expanding an NTFS volume downwards in ntfsresize
       (experimental)
     * fixed feeding the MFT size for stat(2) (Erik Larsson)

Version 2011.4.12AR.4 (Jul 6, 2011)

     * silenced warnings from gcc 4.6
     * accepted the backup bootsector not be to accounted for when cloning
     * fixed dead http links in ntfsprogs manuals (Daniel Baumann)
     * implemented a new option to clear the list of bad sectors in
       ntfsfix

Version 2011.4.12AR.3 (Jun 8, 2011)

     * fixed several bugs in ntfsck
     * fixed several bugs in ntfsfix
     * fixed output formattings in ntfsck, ntfsmove and ntfswipe
     * fixed the description of "inherit" mount option in the manual
     * fixed "relatime" as a default mount option
     * improved compression

Version 2011.4.12AR.1 (May 18, 2011)

     * merged the ntfsprogs tools in
     * fixed "make libs" to only build libraries
     * fixed the included files into ntfsck.c (Fedora)
     * fixed options parsing on OSes with no extended attributes
     * fixed compilation on OpenIndiana (Apostolos Syropoulos)
     * defined a configure option --enable-extras for extra ntfsprogs
       tools (Fedora)
     * fixed setting DOS names when defined with lower-case chars
     * worked around device path canonicalization for use by devmapper
       (basinilya)
     * fixed attribute flags controlling recursive writes
     * defined a mount option big_writes to use application-defined write
       buffer sizes
     * implemented expanding runlists in ntfsresize

Version 2011.1.15AR.4 (Mar 15, 2011)

     * fixed double cluster mapping on very fragmented space
     * fixed getting space for making an index non resident

Version 2011.1.15AR.2 (Feb 16, 2011)

     * fixed expanding an attribute without creating a hole

Version 2011.1.15AR.1 (Feb 3, 2011)

     * enabled expanding an attribute without creating a hole
     * denied direct modifications to metadata files
     * fixed possible wrong hole size when overwriting compressed data
     * improved appending data to a long hole
     * defined option acl to request the use of Posix ACLs

Version 2010.10.2AR.3 (Dec 7, 2010)

     * fixed alignments needed on some processors
     * reorganized options parsing
     * fixed deleting files when using option ignore_case

Version 2010.10.2AR.1 (Oct 17, 2010)

     * implemented the sync mount option
     * fixed Posix ACLs for big-endian computers
     * improved names comparing on big-endian computers
     * implemented a basic check on upcase table
     * forced alignment on cached structs
     * removed an obsolete debug sequence
     * fixed stat(2) for system files with no data

Version 2010.8.8AR.5 (Sep 8, 2010)

     * (unchanged)

Version 2010.8.8AC.4 (Aug 26, 2010)

     * made miscellaneous clarifications to the ntfs-3g manual
     * fixed character translations when standard functions are not
       available
     * fixed checking for already mounted device on non-Linux platforms
     * implemented fsync() and friends

Version 2010.8.8AB.1 (Aug 11, 2010)

     * improved appending data to big or fragmented files

Version 2010.6.31AR.2 (Jul 20, 2010)

     * fixed updating the compressed size
     * fixed processing end of partial runlist for compressed files
     * fixed checking for write errors in setxattr()

Version 2010.6.31AR.1 (Jul 16, 2010)

     * several fixes in compressing files
     * improved sanity checks on a security descriptor
     * fixed processing of options "silent" and "no_def_opts"
     * fixed checking whether the device is already mounted

Version 2010.5.22AC.6 (Jul 2, 2010)

     * reenabled compression in root directory
     * enable/disable compression according to option
     * fixed characters not allowed by Windows in names
     * fixed cached allocation for compressed files
     * renamed option default_permissions to permissions
     * avoided a possible null dereference when creating a stream
     * several fixes in compressing files
     * fixed reading/writing encrypted streams with no data (with efs_raw
       set)

Version 2010.5.16AC.1 (May 29, 2010)

     * fixed 8-byte alignment in cached structures
     * disabled compression on root directory or NTFS version < 3.0
     * fixed data size after an upsizing truncate of a compressed file
     * fixed freeing a full compression block when fragmented
     * disabled macfuse specific callbacks in lowntfs-3g
     * fixed wrong flags when uid/gid are forced in mount options
     * enabled use of fuse cacheing in lowntfs-3g under conditions
     * added a big endian extended attribute name for attrib and times
     * added extended attribute names for creation time
     * enabled renaming of system extended attributes

Version 2010.3.6AC.6 (Apr 23, 2010)

     * fixed the condition for executing utime() and utimensat()
     * enabled truncating (shortening) compressed files

Version 2010.3.6AB.5 (Apr 17, 2010)

     * enabled overwriting on compressed files
     * fixed creating new ACLs after an unusual condition left by chkdsk

Version 2010.3.6AR.4 (Mar 30, 2010)

     * fixed a bad condition for security descriptor upgrade
     * checked Windows file names rules when option windows_names is set
     * reversed the default option for hiding hidden files

Version 2010.3.6AR.2 (Mar 18, 2010)

     * developped "lowntfs-3g", a driver variant using the fuse low-level
       interface
     * fixed a compilation issue with uClibc
     * fixed modifying the read-only flag on a directory
     * fixed bad error checking when closing a compressed file
     * concealed files marked as "hidden" unless option show_hid_files is
       set
     * marked files whose name has a dot initial as "hidden" if option
       hide_dot_files is set
     * redefined a default user mapping (a few changes in mount options)
     * enabled case insensitive file names
     * fixed a bug in ACL inheritance

Version 2010.2.6AR.1 (Feb 25, 2010)

     * fixed options processing when uid, gid, fmask or dmask are present
     * fixed updating reparse tags in parent directories
     * fixed setting archive bit on file and alternated data stream
       creation

Version 2010.1.16AR.1 (Jan 23, 2010)

     * logged making $TXF_DATA resident
     * logged usage of uid==0 and gid!=0

Version 2009.11.14AC.3 (Jan 3, 2010)

     * developed selective timestamp setting by utimensat(2)
     * developed 100ns timestamps
     * fixed compiling issues on OpenSolaris
     * fixed double inode openings for reparse data and object id indexes
     * prevented $TXF_DATA from being made non-resident
     * made $TXF_DATA resident when non-resident on the root directory

Version 2009.11.14AC.2 (Dec 16, 2009)

     * fixed renaming a file when target designates the same file
     * fixed junction points translations when containing non-ascii chars
     * restricted compression to volumes with cluster size not greater
       than 4096
     * fixed compiling issues on OpenSuse and OpenSolaris (partial)

Version 2009.11.14AB.1 (Nov 28, 2009)

     * applied patches for Mac OS X (Erik Larsson)
     * fixed return value for removing a reparse index
     * fixed setting time stamps through extended attributes
     * fixed disabling ownership checking when permissions are disabled
     * fixed renaming when target points to the same file
     * changed internal interfaces to security functions
     * changed internal interfaces to extended attributes functions
     * kept junction points absolute or relative as specified
     * made permissions checks by kernel or by file system selectable
     * removed all double openings of inodes
     * avoided translating file names when found in cache
     * improved caches efficiency by indexing entries
     * kept file information in cache for further needs
     * computed file names collations in a single parsing
     * made sanity checks when setting reparse data of known type
     * fixed setting file attributes to parent directories
     * implemented getting/setting/removing object ids

Version 2009.4.4AR.21 (Sep 30, 2009)

     * fixed cluster allocation when overwriting a hole in a sparse file
     * version merged into ntfs-3g-2009.10.5-RC

Version 2009.4.4AR.19 (Sep 19, 2009)

     * accepted initial spaces in Win32/DOS names
     * fixed access control in access() calls
     * fixed a possible memory leak when setting a DOS name
     * fixed a double inode closing in listxattr()
     * checked parent directory to be writeable in utime()
     * enabled Posix ACLs with older kernels
     * avoided a double opening of an inode in create()

Version 2009.4.4AR.17 (Aug 17, 2009)

     * fixed returned code when querying a non-existent DOS name
     * fixed a possible memory leak when setting a DOS name
     * made possible to set a DOS name identical to corresponding long
       name
     * developped deletion of DOS names
     * fixed checking spaces in Win32 names
     * allowed creating holes in compressed files

Version 2009.4.4AR.16 (Aug 1, 2009)

     * fixed access to user mapping in test environment
     * returned EPERM for getting/setting efsinfo without option efs_raw
     * kept compatibility with older kernels when Posix ACLs are not used

Version 2009.4.4AC.15 (Jul 9, 2009)

     * fixed permissions on created files when the parent directory has a
       default ACL
     * fixed setting archive flag when hard linking a new name
     * developped getting and setting NTFS times

Version 2009.4.4AC.14 (Jul 2, 2009)

     * developped getting and setting DOS names (short 8+3 names)
     * developped handling of Windows archive flag
     * fixed uncacheing of files which were deleted through use of an
       alternate name
     * changed conditions to activate protection modes
     * fixed erroneous rejections of setting efs info
     * improved cluster allocation on volumes nearly full

Version 2009.4.4AR.12 (Jun 17, 2009)

     * logged user mapping errors (which occur before mounting)
     * displayed compile-time options when help is requested
     * fixed a data compression bug causing suboptimal compression

Version 2009.4.4AC.11 (May 20, 2009)

     * fixed permissions for symlinks when no user mapping is defined
     * implemented creating and appending to compressed files
     * implemented backup/restore of encrypted files (by Martin Bene)

Version 2009.4.4AR.10 (May 17, 2009)

     * fixed a macro usage which can be be bad on big-endian processors
     * fixed a version dependency in the security API
     * fixed access control to system extended attributes when Posix ACLs
       are enabled
     * fixed execution access by root when Posix ACLs are enabled on
       kernel >= 2.6.29
     * fixed inheritance of NTFS ACLs and Posix ACLs

Version 2009.4.4AR.1 (Apr 3, 2009)

     * checked NTFS version before setting a reparse point
     * adapted to ntfs-3g-2009.4.4

Version 2009.3.8AR.1 (Mar 26, 2009)

     * fixed an endianness error
     * fed free space in context for calls from security API
     * fixed a bug in a sanity check for junction points
     * adapted to ntfs-3g-2009.3.8

Version 2009.2.1AR.4 (Mar 2, 2009)

     * improved creating gaps in a sparse file, O(n) instead of O(n*n)
     * allowed setting compression flag to a directory
     * fixed moving the standard information attribute to an extended MFT
       record (Szabolcs Szakacsits)
     * fixed creating new reparse points (Faisal Puthuparackat)
     * changed attribute name offset when there is no name (Faisal
       Puthuparackat)

Version 2009.2.1AR.1 (Feb 13, 2009)

     * returned no support when extended attributes are enabled and Posix
       ACL are not
     * avoided logging of removal of non-existent extended attribute
     * fixed listing of non-user extended attributes
     * fixed access control to extended attributes when Posix ACLs are
       enabled
     * improved cluster allocations for fragmented files, O(n) instead of
       O(n*n)
     * integrated into ntfs-3g-2009.2.1

Version 2009.1.1AR.1 (Jan 23, 2009)

     * implemented security, trusted and open name spaces for extended
       attributes
     * relocated the extended attributes mapping code for NTFS attribs
     * integrated into ntfs-3g-2009.1.1

Version 1.5222AC.1 (Jan 6, 2009)

     * enabled Posix ACLs through configure option --enable-posix-acls
       (Szabolcs Szakacsits)
     * fixed ACL backup/restore when special flags are present
     * fixed a memory leak in the security API (only used by tools)
     * improved consistency checks of ACLs
     * dropped specific UTF-8 translations (now integrated into
       ntfs-3g.1.5222-RC)
     * mapped NTFS attribs and reparse data to extended attributes
     * fixed the return value of ntfs_set_file_attributes()
     * integrated into ntfs-3g.1.5222-RC

Version 1.5130AR.1 (Dec 1, 2008)

     * implemented Vista symbolic links as symlinks
     * integrated into ntfs-3g.1.5130

Version 1.5012AR.2 (Nov 21, 2008)

     * implemented junction points as symlinks

Version 1.5012SR.1 (Oct 18, 2008)

     * (unchanged)

Version 1.5012SC.1 (Oct 13, 2008)

     * made the interface to get/set an NTFS ACL available in non-Posix
       ACL builds
     * enabled protections if no mount option but user mapping file is
       found

Version 1.2926SB.1 (Sep 19, 2008)

     * reorganized the security source file and merged the Posix ACL part
     * redefined and cleaned the endianness-dependent operations
     * improved approximation for ACLs built by Windows Administrator
     * made possible to have the owner mentioned again as a designated
       user
     * redefined the options to activate the levels of permissions
       checking
     * made use of fuse checks when "default_permissions" option is used
     * improved unallocated blocks counting
     * made use of a general utf16 to utf8 converter by Bernhard Kaindl
     * fixed read permission in Posix ACL masks
     * made possible to mention root as a designated user or group
     * developed an extended attribute interface to get/set an NTFS ACL
     * implemented access control to extended attributes
     * fixed Posix ACLs cacheing
     * integrated into ntfs-3g.1.2926-RC

Version 1.2918SR.1 (Sep 19, 2008)

     * fixed owner of files when different from Windows owner
     * fixed permissions checks when opening a directory by open()
     * integrated into ntfs-3g-1.2918

Version 1.2812SR.1 (Aug 16, 2008)

     * added entries in security API to process user mappings and Win32
       attribs
     * fixed possible overflows in reading the user mapping file
     * integrated into ntfs-3g-1.2812

Version 1.2712SR.1 (July 13, 2008)

     * fixed a memory leak condition (Posix ACL version only)
     * integrated into ntfs-3g-1.2712

Version 1.2531SR.3 (June 18, 2008)

     * fixed changing mode for files created by standard ntfs-3g

Version 1.2531SR.2 (June 2, 2008)

     * fixed deletions from a sticky directory (on kernels >= 2.6.25)
     * integrated into ntfs-3g-1.2531

Version 1.2506SR.1 (May 6, 2008)

     * integrated into ntfs-3g-1.2506

Version 1.2412SR.2 (Apr 21, 2008)

     * removed trailing '/' circumstances and simplified path
       normalization
     * extended cacheing to any variable type
     * checked an error condition before allowing access
     * improved approximation of Windows-type inheritance
     * fixed computation of implicit uid/gid
     * prevented Windows from inheriting execution right to plain files
     * made possible to access files created by Windows in a directory
       owned by Linux root
     * implemented Posix ACLs (experimental and made available as a patch
       file)

Version 1.2412SR.1 (Apr 14, 2008)

     * improved grants and denials to group
     * improved consistency of ownership for chmod
     * fixed an error return case in chown/chmod
     * integrated into ntfs-3g-1.2412

Version 1.2310SB.5 (Apr 3, 2008)

     * fixed a bug in security API
     * two fixes from Szabolcs Szakacsits

Version 1.2310SB.4 (Mar 17, 2008)

     * fixed processing of security options
     * improved processing of supplementary groups

Version 1.2310SB.3 (Mar 13, 2008)

     * implemented access rights for dynamic supplementary groups
     * implemented an implicit user mapping (Bernhard Kaindl)
     * fixed an endianness error
     * fixed a consistency check in security API
     * fixed a bug when volume could not be mounted

Version 1.2310SR.1 (Mar 10, 2008)

     * changed representation of special mode bits
     * reordered ACE's in canonical order
     * integrated into mainstream version ntfs-3g-1.2310

Version 1.2216SR.3 (Mar 6, 2008)

     * fixed a bug when fetching the group of a file
     * improved consistency checks relative to $Secure

Version 1.2216SR.1 (Feb 18, 2008)

     * integrated into mainstream version ntfs-3g-1.2216

Version 1.2129SR.1 (Jan 30, 2008)

     * integrated into mainstream version ntfs-3g-1.2129

Version 1.2121SC.1 (Jan 23, 2008)

     * integrated into mainstream release candidate ntfs-3g-1.2121-RC

Version 1.1120SC.2 (Jan 16, 2008)

     * improved search for the longest run of unallocated blocks
     * relocated user mapping file to hidden directory .NTFS-3g
     * implemented an option to redefine the location of user mapping file

Version 1.1120SC.1 (Jan 11, 2008)

     * reengineered LRU caches, made generic, and applied to finding inode
       numbers
     * improved comparing Unicode names

Version 1.1120SB.5 (Dec 14, 2007)

     * fixed bad release of index root
     * avoided double check in unlink()
     * added alignment checks in ACL sanity checking
     * redefined ownership of files
     * implemented checks for (static) supplementary groups
     * reengineered permissions cache
     * fixed a bug when getting permissions for the first time

Version 1.1120SB.4 (Dec 3, 2007)

     * fixed "Dr Watson" situation again
     * extended security API for auditing security data
     * fixed a memory leak when user mapping is not activated
     * fixed recognition of alternate world SID
     * fixed compatibility with Windows for allowing writes to group and
       world

Version 1.1120SB.3 (Nov 20, 2007)

     * fixed checking for protected parent directory in several functions
     * fixed clearing setgid if file group does not match process group
     * logged circumstances in which errno is set to EIO
     * set files created by unmapped users as created by root
     * considered security descriptors with no DACL as valid (for "Dr
       Watson")
     * implemented ftruncate() with its special access checking
     * fixed apparent mode for symbolic links
     * fixed time updates in several functions (Yura Pakhuchiy, Szabolcs
       Szakacsits)
     * fixed flags checking in security descriptors
     * fixed access to files owned by root with access granted to a user
     * fixed setting of read-only flag
     * integrated into mainstream version ntfs-3g-1.1120

Version 1.1104SA.1 (Nov 5, 2007)

     * fixed condition for accepting a chgrp
     * fixed header after merging security attributes
     * reorganized file creation to avoid temporary settings
     * fixed updating of ctime in chmod and chown
     * fixed setgid and setuid in directories and when group is same as
       owner
     * cleared gaps in $Secure to avoid chkdsk warnings
     * Integrated into mainstream version ntfs-3g-1.1104

Version 1.1030SA.1 (Oct 29, 2007)

     * Integrated into mainstream version ntfs-3g-1.1030

Version 1.1004SA.3 (Oct 27, 2007)

     * recognized generic SID for creator/owner
     * accepted symbolic names for uid and gid in mapping file
     * fixed several errno values
     * returned the securid and size even if short buffer in security API
     * recognized local users group as meaning world
     * fixed size returned in security API
     * fixed errors in packaging

Version 1.1004SA.2 (Oct 20, 2007)

     * fixed a memory leak case in checking permissions
     * cleaned the code
     * implemented an option for upgrading gracefully individual security
       attributes
     * implemented a security API for tools
     * fixed a case for potential index/data inconsistency
     * improved hash collision detection through a generic get_next_key()
     * fixed unneeded generation of security id after a hash collision
     * fixed possible overflows of SDS-1 into SDS-2
     * stuffed gaps in SDS to prevent it from being made sparse
     * implemented selective inheritance from directories with a securid
       or without
     * implemented special protection modes : sticky, setuid, setgid
     * fixed access()
     * implemented cache extension for legacy directories

Version 1.1004-SA-1 (Oct 6, 2007)

     * fixed a memory corruption case in cacheing of security attributes
     * developped two-way cacheing of security attributes
     * fixed several endianness errors
     * improved code as suggested by Yuval Fledel on Sep 28th
     * moved user mapping file to $Extend/$UserMapping
     * improved finding next index entry when checking for hash collisions
     * integrated into ntfs-3g-1.1004

Version 1.913-SA-3 (Sep 28, 2007)

     * fixed setting of non-inherited initial security descriptor

Version 1.913-SA-2 (Sep 27, 2007)

     * made comments be allowed in mapping file (when first char is #)
     * exchanged log messages when mapping has succeeded/failed
     * fixed tests of standard information length
     * fixed creation of read-only files (requires a create method and
       fuse > 2.6.15)
     * accepted generic R, W and X flags in an ACE (without setting them)
     * accepted (and ignored) extra fields in mapping file
     * implemented access()
     * implemented the collation rule for security hash keys
     * implemented insertion of security descriptors in $Secure
     * checked user has same group as file for chgrp
     * implemented a different ACL set if owner or group is root
     * implemented a different ACL set if owner and group are the same
     * made a preference for real groups against groups specific to a user
     * renamed mapping file as "$Mapping"
     * entered inherited initial security descriptor into $Secure (if
       v3.x)
     * set the read-only attribute (left unused) according to S_IWUSR
     * implemented a default mapping for single-user systems
     * developed cacheing of uid, gid and mode (if v3.x)
     * implemented "inherit" mount option to force inheritance on created
       files
     * integrated into ntfs-3g-1.913

Version 1.810-SA-1 (Sep 5, 2007)

     * implemented a two-way mapping of Linux modes to NTFS ACL's
     * implemented interpretation of a mapping file
     * implemented creation of ACL's for file creation, chmod, chown and
       chgrp
     * implemented storing of ACL's as a file attribute (NTFS v 1.x)
     * implemented interpretation of ACL's for stat
     * implemented checking of rights for open, truncate, chmod, chown,
       create, ln, unlink
     * implemented a Windows utility to help in building the mapping file


    To report any problem, please post to the [25]support forum hosted by
    Tuxera
    Page is maintained by Jean-Pierre André

References

   1. http://www.tuxera.com/community/ntfs-3g-download/
   2. http://www.tuxera.com/
   3. http://www.tuxera.com/community/ntfs-3g-download/
   4. http://www.tuxera.com/community/ntfs-3g-faq/#questions
   5. http://www.tuxera.com/community/ntfs-3g-faq/#bugreport
   6. http://tuxera.com/forum
   7. http://www.tuxera.com/community/ntfs-3g-faq/#lists
   8. http://www.tuxera.com/community/release-history/
   9. http://jp-andre.pagesperso-orange.fr/advanced-ntfs-3g.html
  10. http://jp-andre.pagesperso-orange.fr/permissions.html
  11. http://jp-andre.pagesperso-orange.fr/permissions.html#useofacl
  12. http://jp-andre.pagesperso-orange.fr/permissions.html#usermapping
  13. http://jp-andre.pagesperso-orange.fr/permissions.html#posixacls
  14. http://jp-andre.pagesperso-orange.fr/permissions.html#options
  15. http://jp-andre.pagesperso-orange.fr/permissions.html#limitations
  16. http://jp-andre.pagesperso-orange.fr/junctions.html
  17. http://jp-andre.pagesperso-orange.fr/junctions.html#dirjunctions
  18. http://jp-andre.pagesperso-orange.fr/junctions.html#voljunctions
  19. http://jp-andre.pagesperso-orange.fr/junctions.html#symlinks
  20. http://jp-andre.pagesperso-orange.fr/extend-attr.html
  21. http://jp-andre.pagesperso-orange.fr/compression.html
  22. http://jp-andre.pagesperso-orange.fr/usermap.html
  23. http://jp-andre.pagesperso-orange.fr/secaudit.html
  24. http://jp-andre.pagesperso-orange.fr/openindiana-ntfs-3g.html
  25. http://tuxera.com/forum/
